#include "StdAfx.h"
#include "StealthList.h"
#include "CallList.h"
#include "ServerData.h"
#include "ServerSIP.h"


cStealthData::cStealthData()
{
	m_unStealthIdCount = 0;

	m_objStealthListINT = gcnew Hashtable();
    m_objStealthListTEXT = gcnew Hashtable();
}

cStealthList::cStealthList(void)
{
	m_unStealthIdCount = 0;

	m_objStealthListTEXT = gcnew Hashtable();
    m_objStealthListINT = gcnew Hashtable();
}

unsigned int cStealthList::ChooseStealthId()
{
    while (true)
    {
        m_unStealthIdCount++;

        if (FindStealthCall(m_unStealthIdCount) == nullptr)
            break;
    }

    return m_unStealthIdCount;
}

void cStealthList::AddCallToStealthList(cCallData^ objCallData)
{
    objCallData->m_unStealthId = ChooseStealthId();

    m_objStealthListINT->Add(objCallData->m_unStealthId, objCallData);
    m_objStealthListTEXT->Add(objCallData->m_sStealthDialNo, objCallData);
}

void cStealthList::FreeCaptureCall(cCallData^ objCallData)
{
    if(objCallData->m_unStealthId != 0)
    {
        cCallData^ objStealthCallData = FindStealthCall(objCallData->m_unStealthId);

        if(objStealthCallData != nullptr)
        {
            objStealthCallData->m_bStealthListening = false;

            int nStealthSessionId = cServerSIP::m_objServerSIP->m_objServerData->GetStealthSessionId();
            cServerSIP::m_objServerSIP->AddCallToSession(objStealthCallData, nStealthSessionId);
        }
    }
}

void cStealthList::TryCaptureCall(cCallData^ objCallData)
{
    cCallData^ objStealthCallData = FindStealthCall(objCallData->m_sUserId);

    if(objStealthCallData == nullptr)
        return;

    if (objStealthCallData->m_bStealthListening == true)
        return;
    
    cServerSIP::m_objServerSIP->AddCallToSession(objStealthCallData, objCallData->m_nSessionId);

    objStealthCallData->m_bStealthListening = true;
    objCallData->m_unStealthId = objStealthCallData->m_unStealthId;
}

cCallData^ cStealthList::FindStealthCall(unsigned int unStealthId)
{
    return (cCallData^) m_objStealthListINT[unStealthId];
}

cCallData^ cStealthList::FindStealthCall(String^ sDialNo)
{
    return (cCallData^) m_objStealthListTEXT[sDialNo->ToLower()];
}

void cStealthList::RemoveStealthCall(cCallData^ objCallData)
{
    m_objStealthListINT->Remove(objCallData->m_unStealthId);
    m_objStealthListTEXT->Remove(objCallData->m_sStealthDialNo);
}

void cStealthList::DeleteAll()
{
    m_objStealthListTEXT->Clear();
    m_objStealthListINT->Clear();
}