// CallList.cpp: implementation of the CCallList class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ServerSIP.h"
#include "CallList.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCallList::CCallList()
{
	InitHashTable(256, TRUE);
}

CCallList::~CCallList()
{
	DeleteAll();
}

CCallData* CCallList::AddCall(long lCallId)
{
	CCallData* pCallData = new CCallData;
	pCallData->m_lCallId = lCallId;
	
	SetAt(lCallId, pCallData);

	return pCallData;
}

void CCallList::RemoveCall(CCallData* pCallData)
{
	RemoveKey(pCallData->m_lCallId);
	delete pCallData;
}

CCallData* CCallList::FindCall(long lCallId)
{
	CCallData* pCallData;
	if(!Lookup(lCallId, pCallData)) return NULL;

	return pCallData;
}

void CCallList::DeleteAll()
{
	long lKey;
	
	CCallData* pCallData;
	CCallData** pCloseCallList;
		
	int nTotalCall = GetCount();
	
	pCloseCallList = new CCallData* [nTotalCall];

	POSITION pos = GetStartPosition();

	for(int nCount = 0; pos != NULL; nCount++)
	{
		GetNextAssoc( pos, lKey, pCallData);
		pCloseCallList[nCount] = pCallData;
	}

	for(nCount = 0; nCount < nTotalCall; nCount++)
	{
		CServerSIP::m_pServerSIP->CloseCall(pCloseCallList[nCount]);
	}
		
	RemoveAll();

	delete[] pCloseCallList;
}

