// Registry.cpp: implementation of the CRegistry class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Registry.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

#define SUB_KEY_BUFFER_SIZE	2000

CRegistry::CRegistry()
{
	if(::RegCreateKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\VaxTeleSrvSIP", 0, NULL, 0, KEY_ALL_ACCESS, NULL, &m_hKey, NULL) != ERROR_SUCCESS)
		m_hKey = NULL;
}

CRegistry::~CRegistry()
{
	::RegCloseKey(m_hKey);
}


CString CRegistry::GetStealthListenerMusic()
{
	char sData[SUB_KEY_BUFFER_SIZE] = "\0";
	DWORD dwCount = SUB_KEY_BUFFER_SIZE;
	
	if(::RegQueryValueEx(m_hKey, "StealthListenMusic", NULL, NULL, (BYTE*) sData, &dwCount) != ERROR_SUCCESS)
		return "";
	
	return sData;
}


BOOL CRegistry::SetStealthListenerMusic(LPCTSTR sPlayWave)
{
	if(::RegSetValueEx(m_hKey, "StealthListenMusic", 0 , REG_SZ, (BYTE*) sPlayWave, ::lstrlen(sPlayWave)) != ERROR_SUCCESS)
		return FALSE;

	return TRUE;
}

BOOL CRegistry::SetHoldMusic(LPCTSTR sPlayWave)
{
	if(::RegSetValueEx(m_hKey, "HoldMusic", 0 , REG_SZ, (BYTE*) sPlayWave, ::lstrlen(sPlayWave)) != ERROR_SUCCESS)
		return FALSE;

	return TRUE;
}


CString CRegistry::GetHoldMusic()
{
	char sData[SUB_KEY_BUFFER_SIZE] = "\0";
	DWORD dwCount = SUB_KEY_BUFFER_SIZE;
	
	if(::RegQueryValueEx(m_hKey, "HoldMusic", NULL, NULL, (BYTE*) sData, &dwCount) != ERROR_SUCCESS)
		return "";
	
	return sData;
}

BOOL CRegistry::SetDialToneMusic(LPCTSTR sPlayWave)
{
	if(::RegSetValueEx(m_hKey, "DialToneMusic", 0 , REG_SZ, (BYTE*) sPlayWave, ::lstrlen(sPlayWave)) != ERROR_SUCCESS)
		return FALSE;

	return TRUE;
}

CString CRegistry::GetDialToneMusic()
{
	char sData[SUB_KEY_BUFFER_SIZE] = "\0";
	DWORD dwCount = SUB_KEY_BUFFER_SIZE;
	
	if(::RegQueryValueEx(m_hKey, "DialToneMusic", NULL, NULL, (BYTE*) sData, &dwCount) != ERROR_SUCCESS)
		return "";
	
	return sData;
}


BOOL CRegistry::SetCOMM(LPCTSTR sListenIP, LPCTSTR sListenPort, LPCTSTR sDominRealm)
{
	if(::RegSetValueEx(m_hKey, "ListenIP", 0 , REG_SZ, (BYTE*) sListenIP, ::lstrlen(sListenIP)) != ERROR_SUCCESS)
		return FALSE;

	if(::RegSetValueEx(m_hKey, "ListenPort", 0 , REG_SZ, (BYTE*) sListenPort, ::lstrlen(sListenPort)) != ERROR_SUCCESS)
		return FALSE;

	if(::RegSetValueEx(m_hKey, "DomainRealm", 0 , REG_SZ, (BYTE*) sDominRealm, ::lstrlen(sDominRealm)) != ERROR_SUCCESS)
		return FALSE;

	return TRUE;
}

BOOL CRegistry::GetCOMM(CString& sListenIP, CString& sListenPort, CString& sDominRealm)
{
	char sData[SUB_KEY_BUFFER_SIZE] = "\0";
	
	DWORD dwCount = SUB_KEY_BUFFER_SIZE;
	
	if(::RegQueryValueEx(m_hKey, "ListenIP", NULL, NULL, (BYTE*) sData, &dwCount) != ERROR_SUCCESS)
		return FALSE;
	
	sListenIP = sData;

	::memset(sData, 0, SUB_KEY_BUFFER_SIZE);
	dwCount = SUB_KEY_BUFFER_SIZE;

	if(::RegQueryValueEx(m_hKey, "ListenPort", NULL, NULL, (BYTE*) sData, &dwCount) != ERROR_SUCCESS)
		return FALSE;

	sListenPort = sData;

	::memset(sData, 0, SUB_KEY_BUFFER_SIZE);
	dwCount = SUB_KEY_BUFFER_SIZE;

	if(::RegQueryValueEx(m_hKey, "DomainRealm", NULL, NULL, (BYTE*) sData, &dwCount) != ERROR_SUCCESS)
		return FALSE;

	sDominRealm = sData;

	return TRUE;
}

///////////////////////////////////////////////////////
///////////////////////////////////////////////////////

BOOL CRegistry::RemoveQueue(LPCTSTR sQueue)
{
	char sSubKey[SUB_KEY_BUFFER_SIZE] = "\0";
	::_stprintf(sSubKey, "Queue\\%s", sQueue); 

	if(::RegDeleteKey(m_hKey, sSubKey) != ERROR_SUCCESS)
		return FALSE;

	return TRUE;
}

void CRegistry::EnumQueue(CStringList* pQueueList)
{
	HKEY hKey;
		
	if(::RegOpenKeyEx(m_hKey, "Queue", 0, KEY_ALL_ACCESS, &hKey) != ERROR_SUCCESS)
		return;
	 
	char sQueue[SUB_KEY_BUFFER_SIZE] = "\0";
	DWORD dwSize = SUB_KEY_BUFFER_SIZE;

	for(int nCount = 0;;nCount++)
	{
		if(::RegEnumKeyEx(hKey, nCount, sQueue, &dwSize, 0, NULL, NULL, NULL)  != ERROR_SUCCESS)
			break;
		
		pQueueList->AddTail(sQueue);

		::memset(sQueue, 0, SUB_KEY_BUFFER_SIZE);
		dwSize = SUB_KEY_BUFFER_SIZE;
	}

	::RegCloseKey(hKey);
}

BOOL CRegistry::GetQueue(LPCTSTR sQueue, CQueueReg* pQueueReg)
{
	HKEY hKey;
	
	char sData[SUB_KEY_BUFFER_SIZE] = "\0";
	::_stprintf(sData, "Queue\\%s", sQueue); 

	if(::RegOpenKeyEx(m_hKey, sData, 0, KEY_ALL_ACCESS, &hKey) != ERROR_SUCCESS)
		return FALSE;
	
	::memset(sData, 0, SUB_KEY_BUFFER_SIZE);
	DWORD dwBuffSize = SUB_KEY_BUFFER_SIZE;
	
	if(::RegQueryValueEx(hKey, "playwave", NULL, NULL, (BYTE*) sData, &dwBuffSize) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}

	pQueueReg->m_sPlayWave = sData;
	
	char sBuffer[SUB_KEY_BUFFER_SIZE] = "\0";
	int nCount = 0;
	
	for(nCount = 0;; nCount++)
	{
		::_stprintf(sBuffer, "op-%d", nCount);
				
		::memset(sData, 0, SUB_KEY_BUFFER_SIZE);
		dwBuffSize = SUB_KEY_BUFFER_SIZE;
		
		if(::RegQueryValueEx(hKey, sBuffer, NULL, NULL, (BYTE*) sData, &dwBuffSize) != ERROR_SUCCESS)
			break;

		pQueueReg->m_objQueueOPList.AddTail(sData);
	}


	for(nCount = 0;; nCount++)
	{
		::_stprintf(sBuffer, "digit-%d", nCount);
				
		::memset(sData, 0, SUB_KEY_BUFFER_SIZE);
		dwBuffSize = SUB_KEY_BUFFER_SIZE;
		
		if(::RegQueryValueEx(hKey, sBuffer, NULL, NULL, (BYTE*) sData, &dwBuffSize) != ERROR_SUCCESS)
			break;

		pQueueReg->m_objPressDigitList.AddTail(sData);
	}

	for(nCount = 0;; nCount++)
	{
		::_stprintf(sBuffer, "digituser-%d", nCount);
				
		::memset(sData, 0, SUB_KEY_BUFFER_SIZE);
		dwBuffSize = SUB_KEY_BUFFER_SIZE;
		
		if(::RegQueryValueEx(hKey, sBuffer, NULL, NULL, (BYTE*) sData, &dwBuffSize) != ERROR_SUCCESS)
			break;

		pQueueReg->m_objPressDigitUserList.AddTail(sData);
	}

	::memset(sData, 0, SUB_KEY_BUFFER_SIZE);
	dwBuffSize = SUB_KEY_BUFFER_SIZE;
	
	if(::RegQueryValueEx(hKey, "digitplaywave", NULL, NULL, (BYTE*) sData, &dwBuffSize) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}

	pQueueReg->m_sPressDigitPlayWave = sData;
	
	::RegCloseKey(hKey);
			
	return TRUE;

}

BOOL CRegistry::SetQueue(LPCTSTR sQueue, CQueueReg* pQueueReg)
{
	RemoveQueue(sQueue);
	
	HKEY hKey;
	
	char sSubKey[SUB_KEY_BUFFER_SIZE] = "\0";
	::_stprintf(sSubKey, "Queue\\%s", sQueue);
		
	if(::RegCreateKeyEx(m_hKey, sSubKey, 0, NULL, 0, KEY_ALL_ACCESS, NULL, &hKey, NULL) != ERROR_SUCCESS)
		return FALSE;

	if(::RegSetValueEx(hKey, "playwave", 0 , REG_SZ, (BYTE*) pQueueReg->m_sPlayWave.GetBuffer(0), pQueueReg->m_sPlayWave.GetLength()) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}
	
	char sBuffer[SUB_KEY_BUFFER_SIZE] = "\0";
	CString sData;
	int nCount;
	
	for(nCount = 0; nCount < pQueueReg->m_objQueueOPList.GetCount(); nCount++)
	{
		::_stprintf(sBuffer, "op-%d", nCount);
		
		POSITION pos = pQueueReg->m_objQueueOPList.FindIndex(nCount);
		sData = pQueueReg->m_objQueueOPList.GetAt(pos);
		
		if(::RegSetValueEx(hKey, sBuffer, 0 , REG_SZ, (BYTE*) sData.GetBuffer(0), sData.GetLength()) != ERROR_SUCCESS)
			break;
	}

	for(nCount = 0; nCount < pQueueReg->m_objPressDigitList.GetCount(); nCount++)
	{
		::_stprintf(sBuffer, "digit-%d", nCount);
		
		POSITION pos = pQueueReg->m_objPressDigitList.FindIndex(nCount);
		sData = pQueueReg->m_objPressDigitList.GetAt(pos);
		
		if(::RegSetValueEx(hKey, sBuffer, 0 , REG_SZ, (BYTE*) sData.GetBuffer(0), sData.GetLength()) != ERROR_SUCCESS)
			break;
	}

	for(nCount = 0; nCount < pQueueReg->m_objPressDigitUserList.GetCount(); nCount++)
	{
		::_stprintf(sBuffer, "digituser-%d", nCount);
		
		POSITION pos = pQueueReg->m_objPressDigitUserList.FindIndex(nCount);
		sData = pQueueReg->m_objPressDigitUserList.GetAt(pos);
		
		if(::RegSetValueEx(hKey, sBuffer, 0 , REG_SZ, (BYTE*) sData.GetBuffer(0), sData.GetLength()) != ERROR_SUCCESS)
			break;
	}

	if(::RegSetValueEx(hKey, "digitplaywave", 0 , REG_SZ, (BYTE*) pQueueReg->m_sPressDigitPlayWave.GetBuffer(0), pQueueReg->m_sPressDigitPlayWave.GetLength()) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}
	
	
	::RegCloseKey(hKey);

	return TRUE;

}

BOOL CRegistry::IsQueueExist(LPCTSTR sQueue)
{
	HKEY hKey;
	
	char sSubKey[SUB_KEY_BUFFER_SIZE] = "\0";
	::_stprintf(sSubKey, "Queue\\%s", sQueue); 

	if(::RegOpenKeyEx(m_hKey, sSubKey, 0, KEY_ALL_ACCESS, &hKey) != ERROR_SUCCESS)
		return FALSE;
	
	::RegCloseKey(hKey);

	return TRUE;
}

//////////////////////////////////////////////
//////////////////////////////////////////////

BOOL CRegistry::RemoveLogin(LPCTSTR sLogin)
{
	char sSubKey[SUB_KEY_BUFFER_SIZE] = "\0";
	::_stprintf(sSubKey, "Login\\%s", sLogin); 

	if(::RegDeleteKey(m_hKey, sSubKey) != ERROR_SUCCESS)
		return FALSE;

	return TRUE;
}


BOOL CRegistry::IsLoginStealth(LPCTSTR sLogin)
{
	HKEY hKey;
	
	char sSubKey[SUB_KEY_BUFFER_SIZE] = "\0";
	::_stprintf(sSubKey, "Login\\%s", sLogin); 
	
	if(::RegOpenKeyEx(m_hKey, sSubKey, 0, KEY_ALL_ACCESS, &hKey) != ERROR_SUCCESS)
			return FALSE;
	
	BOOL bStealth;
	DWORD dwSize = sizeof(BOOL);
	
	if(::RegQueryValueEx(hKey, "stealth", NULL, NULL, (BYTE*) &bStealth, &dwSize) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}

	::RegCloseKey(hKey);

	return bStealth;
}

void CRegistry::EnumLogin(CStringList* pLoginList)
{
	HKEY hKey;
		
	if(::RegOpenKeyEx(m_hKey, "Login", 0, KEY_ALL_ACCESS, &hKey) != ERROR_SUCCESS)
		return;
	
	char sLoginBuff[SUB_KEY_BUFFER_SIZE] = "\0";
	DWORD dwSize = SUB_KEY_BUFFER_SIZE;
		
	for(int nCount = 0;;nCount++)
	{
		if(::RegEnumKeyEx(hKey, nCount, sLoginBuff, &dwSize, 0, NULL, NULL, NULL)  != ERROR_SUCCESS)
				break;
	
		pLoginList->AddTail(sLoginBuff);

		::memset(sLoginBuff, 0, SUB_KEY_BUFFER_SIZE);
		dwSize = SUB_KEY_BUFFER_SIZE;
	}

	::RegCloseKey(hKey);
}

BOOL CRegistry::GetLogin(LPCTSTR sLogin, CLoginReg* pLoginReg)
{
	HKEY hKey;
	
	char sBuff[SUB_KEY_BUFFER_SIZE] = "\0";
	::_stprintf(sBuff, "Login\\%s", sLogin); 

	if(::RegOpenKeyEx(m_hKey, sBuff, 0, KEY_ALL_ACCESS, &hKey) != ERROR_SUCCESS)
		return FALSE;
	
	::memset(sBuff, 0, SUB_KEY_BUFFER_SIZE);
	DWORD dwBuffSize = SUB_KEY_BUFFER_SIZE;
	
	if(::RegQueryValueEx(hKey, "password", NULL, NULL, (BYTE*) sBuff, &dwBuffSize) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}

	pLoginReg->m_sPassword = sBuff;
	
	::memset(sBuff, 0, SUB_KEY_BUFFER_SIZE);
	dwBuffSize = SUB_KEY_BUFFER_SIZE;

	if(::RegQueryValueEx(hKey, "codec", NULL, NULL, (BYTE*) sBuff, &dwBuffSize) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}

	pLoginReg->m_sCodec = sBuff;
		
	dwBuffSize = sizeof(BOOL);
	if(::RegQueryValueEx(hKey, "block", NULL, NULL, (BYTE*) &pLoginReg->m_bBlock, &dwBuffSize) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}
	
	dwBuffSize = sizeof(BOOL);
	if(::RegQueryValueEx(hKey, "stealth", NULL, NULL, (BYTE*) &pLoginReg->m_bStealth, &dwBuffSize) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}
	
	::RegCloseKey(hKey);

	return TRUE;

}

BOOL CRegistry::SetLogin(LPCTSTR sLogin, CLoginReg* pLoginReg)
{
	HKEY hKey;
	
	char sSubKey[SUB_KEY_BUFFER_SIZE] = "\0";
	::_stprintf(sSubKey, "Login\\%s", sLogin); 
		
	if(::RegCreateKeyEx(m_hKey, sSubKey, 0, NULL, 0, KEY_ALL_ACCESS, NULL, &hKey, NULL) != ERROR_SUCCESS)
		return FALSE;

	if(::RegSetValueEx(hKey, "password", 0 , REG_SZ, (BYTE*) pLoginReg->m_sPassword.GetBuffer(0), pLoginReg->m_sPassword.GetLength()) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}

	if(::RegSetValueEx(hKey, "codec", 0 , REG_SZ, (BYTE*) pLoginReg->m_sCodec.GetBuffer(0), pLoginReg->m_sCodec.GetLength()) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}

	DWORD dwRegVal = pLoginReg->m_bBlock;

	if(::RegSetValueEx(hKey, "block", 0 , REG_DWORD, (BYTE*) &dwRegVal, sizeof(DWORD)) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}

	dwRegVal = pLoginReg->m_bStealth;
	
	if(::RegSetValueEx(hKey, "stealth", 0 , REG_DWORD, (BYTE*) &dwRegVal, sizeof(DWORD)) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}

	::RegCloseKey(hKey);

	return TRUE;

}

BOOL CRegistry::IsLoginExist(LPCTSTR sLogin)
{
	HKEY hKey;
	
	char sSubKey[SUB_KEY_BUFFER_SIZE] = "\0";
	::_stprintf(sSubKey, "Login\\%s", sLogin); 

	if(::RegOpenKeyEx(m_hKey, sSubKey, 0, KEY_ALL_ACCESS, &hKey) != ERROR_SUCCESS)
		return FALSE;
	
	::RegCloseKey(hKey);

	return TRUE;
}

//////////////////////////////////////////////////
//////////////////////////////////////////////////

BOOL CRegistry::RemoveLine(LPCTSTR sLine)
{
	char sSubKey[SUB_KEY_BUFFER_SIZE] = "\0";
	::_stprintf(sSubKey, "Line\\%s", sLine); 

	if(::RegDeleteKey(m_hKey, sSubKey) != ERROR_SUCCESS)
		return FALSE;

	return TRUE;
}

BOOL CRegistry::IsLineExist(LPCTSTR sLine)
{
	HKEY hKey;
	
	char sSubKey[SUB_KEY_BUFFER_SIZE] = "\0";
	::_stprintf(sSubKey, "Line\\%s", sLine); 

	if(::RegOpenKeyEx(m_hKey, sSubKey, 0, KEY_ALL_ACCESS, &hKey) != ERROR_SUCCESS)
		return FALSE;
	
	::RegCloseKey(hKey);

	return TRUE;
}

void CRegistry::EnumLine(CStringList* pLineList)
{
	HKEY hKey;
		
	if(::RegOpenKeyEx(m_hKey, "Line", 0, KEY_ALL_ACCESS, &hKey) != ERROR_SUCCESS)
		return;
	
	char sLine[SUB_KEY_BUFFER_SIZE] = "\0";
	DWORD dwSize = SUB_KEY_BUFFER_SIZE;

	for(int nCount = 0;;nCount++)
	{
		if(::RegEnumKeyEx(hKey, nCount, sLine, &dwSize, 0, NULL, NULL, NULL)  != ERROR_SUCCESS)
			break;

		pLineList->AddTail(sLine);

		::memset(sLine, 0, SUB_KEY_BUFFER_SIZE);
		dwSize = SUB_KEY_BUFFER_SIZE;
	}

	::RegCloseKey(hKey);
}

BOOL CRegistry::SetLine(LPCTSTR sLineName, CLineReg* pLineReg)
{
	HKEY hKey;
	
	char sBuff[SUB_KEY_BUFFER_SIZE] = "\0";
	::_stprintf(sBuff, "Line\\%s", sLineName); 
		
	if(::RegCreateKeyEx(m_hKey, sBuff, 0, NULL, 0, KEY_ALL_ACCESS, NULL, &hKey, NULL) != ERROR_SUCCESS)
		return FALSE;

	if(::RegSetValueEx(hKey, "displayname", 0 , REG_SZ, (BYTE*) pLineReg->m_sDisplayName.GetBuffer(0), pLineReg->m_sDisplayName.GetLength()) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}

	if(::RegSetValueEx(hKey, "username", 0 , REG_SZ, (BYTE*) pLineReg->m_sUserName.GetBuffer(0), pLineReg->m_sUserName.GetLength()) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}

	if(::RegSetValueEx(hKey, "authuser", 0 , REG_SZ, (BYTE*) pLineReg->m_sAuthUser.GetBuffer(0), pLineReg->m_sAuthUser.GetLength()) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}

	if(::RegSetValueEx(hKey, "password", 0 , REG_SZ, (BYTE*) pLineReg->m_sPassword.GetBuffer(0), pLineReg->m_sPassword.GetLength()) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}

	if(::RegSetValueEx(hKey, "realm", 0 , REG_SZ, (BYTE*) pLineReg->m_sRealm.GetBuffer(0), pLineReg->m_sRealm.GetLength()) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}

	if(::RegSetValueEx(hKey, "proxy", 0 , REG_SZ, (BYTE*) pLineReg->m_sProxy.GetBuffer(0), pLineReg->m_sProxy.GetLength()) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}

	if(::RegSetValueEx(hKey, "outboundproxy", 0 , REG_SZ, (BYTE*) pLineReg->m_sOutboundProxy.GetBuffer(0), pLineReg->m_sOutboundProxy.GetLength()) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}
	
	if(::RegSetValueEx(hKey, "codec", 0 , REG_SZ, (BYTE*) pLineReg->m_sCodec.GetBuffer(0), pLineReg->m_sCodec.GetLength()) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}

	if(::RegSetValueEx(hKey, "regonstartup", 0 , REG_DWORD, (BYTE*) &pLineReg->m_bRegister, sizeof(DWORD)) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}

	if(::RegSetValueEx(hKey, "incalltype", 0 , REG_SZ, (BYTE*) pLineReg->m_sInCallType.GetBuffer(0), pLineReg->m_sInCallType.GetLength()) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}

	if(::RegSetValueEx(hKey, "incallto", 0 , REG_SZ, (BYTE*) pLineReg->m_sInCallTo.GetBuffer(0), pLineReg->m_sInCallTo.GetLength()) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}
	
	return TRUE;
}


BOOL CRegistry::GetLine(LPCTSTR sLineName, CLineReg* pLineReg)
{
	HKEY hKey;
	
	char sBuff[SUB_KEY_BUFFER_SIZE] = "\0";
	::_stprintf(sBuff, "Line\\%s", sLineName); 
		
	if(::RegOpenKeyEx(m_hKey, sBuff, 0, KEY_ALL_ACCESS, &hKey) != ERROR_SUCCESS)
		return FALSE;

	::memset(sBuff, 0, SUB_KEY_BUFFER_SIZE);
	DWORD dwBuffSize = SUB_KEY_BUFFER_SIZE;
	
	if(::RegQueryValueEx(hKey, "displayname", NULL, NULL, (BYTE*) sBuff, &dwBuffSize) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}

	pLineReg->m_sDisplayName = sBuff;

	::memset(sBuff, 0, SUB_KEY_BUFFER_SIZE);
	dwBuffSize = SUB_KEY_BUFFER_SIZE;

	if(::RegQueryValueEx(hKey, "username", NULL, NULL, (BYTE*) sBuff, &dwBuffSize) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}

	pLineReg->m_sUserName = sBuff;
	
	::memset(sBuff, 0, SUB_KEY_BUFFER_SIZE);
	dwBuffSize = SUB_KEY_BUFFER_SIZE;

	if(::RegQueryValueEx(hKey, "authuser", NULL, NULL, (BYTE*) sBuff, &dwBuffSize) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}

	pLineReg->m_sAuthUser = sBuff;

	::memset(sBuff, 0, SUB_KEY_BUFFER_SIZE);
	dwBuffSize = SUB_KEY_BUFFER_SIZE;

	if(::RegQueryValueEx(hKey, "password", NULL, NULL, (BYTE*) sBuff, &dwBuffSize) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}

	pLineReg->m_sPassword = sBuff;

	::memset(sBuff, 0, SUB_KEY_BUFFER_SIZE);
	dwBuffSize = SUB_KEY_BUFFER_SIZE;

	if(::RegQueryValueEx(hKey, "realm", NULL, NULL, (BYTE*) sBuff, &dwBuffSize) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}

	pLineReg->m_sRealm = sBuff;

	::memset(sBuff, 0, SUB_KEY_BUFFER_SIZE);
	dwBuffSize = SUB_KEY_BUFFER_SIZE;

	if(::RegQueryValueEx(hKey, "proxy", NULL, NULL, (BYTE*) sBuff, &dwBuffSize) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}

	pLineReg->m_sProxy = sBuff;

	::memset(sBuff, 0, SUB_KEY_BUFFER_SIZE);
	dwBuffSize = SUB_KEY_BUFFER_SIZE;

	if(::RegQueryValueEx(hKey, "outboundproxy", NULL, NULL, (BYTE*) sBuff, &dwBuffSize) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}

	pLineReg->m_sOutboundProxy = sBuff;

	
	::memset(sBuff, 0, SUB_KEY_BUFFER_SIZE);
	dwBuffSize = SUB_KEY_BUFFER_SIZE;

	if(::RegQueryValueEx(hKey, "codec", NULL, NULL, (BYTE*) sBuff, &dwBuffSize) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}

	pLineReg->m_sCodec = sBuff;
			
	dwBuffSize = sizeof(BOOL);
	if(::RegQueryValueEx(hKey, "regonstartup", NULL, NULL, (BYTE*) &pLineReg->m_bRegister, &dwBuffSize) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}
				
	::memset(sBuff, 0, SUB_KEY_BUFFER_SIZE);
	dwBuffSize = SUB_KEY_BUFFER_SIZE;

	if(::RegQueryValueEx(hKey, "incalltype", NULL, NULL, (BYTE*) sBuff, &dwBuffSize) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}

	pLineReg->m_sInCallType = sBuff;

	::memset(sBuff, 0, SUB_KEY_BUFFER_SIZE);
	dwBuffSize = SUB_KEY_BUFFER_SIZE;
	
	if(::RegQueryValueEx(hKey, "incallto", NULL, NULL, (BYTE*) sBuff, &dwBuffSize) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}

	pLineReg->m_sInCallTo = sBuff;
	
	return TRUE;
}

/*
CString CRegistry::GetError(int nCount)
{
	HKEY hKey;
		
	if(::RegOpenKeyEx(m_hKey, "ErrorReport", 0, KEY_ALL_ACCESS, &hKey) != ERROR_SUCCESS)
		return "";
		
	char sErrorNo[128] = "\0";
	::_stprintf(sErrorNo, "%d", nCount);
	
	char sErrorMsg[SUB_KEY_BUFFER_SIZE] = "\0";
	DWORD dwMsgSize = SUB_KEY_BUFFER_SIZE;

	if(::RegQueryValueEx(hKey, sErrorNo, NULL, NULL, (BYTE*) sErrorMsg, &dwMsgSize) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return "";
	}

	::RegCloseKey(hKey);

	return sErrorMsg;
}


void CRegistry::SetErrorCount(DWORD dwErrorCount)
{
	HKEY hKey;
	if(::RegOpenKeyEx(m_hKey, "ErrorReport", 0, KEY_ALL_ACCESS, &hKey) != ERROR_SUCCESS)
		return;
	
	DWORD dwValueSize = sizeof(DWORD);
	
	::RegSetValueEx(hKey, "ErrorCount", 0 , REG_DWORD, (BYTE*) &dwErrorCount, dwValueSize);
	::RegCloseKey(hKey);
}

DWORD CRegistry::GetErrorCount()
{
	HKEY hKey;
	if(::RegOpenKeyEx(m_hKey, "ErrorReport", 0, KEY_ALL_ACCESS, &hKey) != ERROR_SUCCESS)
		return 0;
	
	DWORD dwErrorCount = 0;
	DWORD dwValueSize = sizeof(DWORD);
	
	if(::RegQueryValueEx(hKey, "ErrorCount", NULL, NULL, (BYTE*) &dwErrorCount, &dwValueSize) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return 0;
	}
	
	::RegCloseKey(hKey);

	return dwErrorCount;
}

void CRegistry::SetError(int nErrorCode, LPCTSTR sErrorMsg)
{
	HKEY hKey;
	
	if(::RegCreateKeyEx(m_hKey, "ErrorReport", 0, NULL, 0, KEY_ALL_ACCESS, NULL, &hKey, NULL) != ERROR_SUCCESS)
		return;
	
	DWORD dwErrorCount = GetErrorCount();
	
	char sErrorCount[128] = "\0";
	::_stprintf(sErrorCount, "%d", dwErrorCount);

	char sRegErrorMsg[SUB_KEY_BUFFER_SIZE] = "\0";

	if(nErrorCode != 0)
		::_stprintf(sRegErrorMsg, "%d : %s", nErrorCode, sErrorMsg); 
	else
		::_stprintf(sRegErrorMsg, "%s", sErrorMsg); 
		
	::RegSetValueEx(hKey, sErrorCount, 0 , REG_SZ, (BYTE*) sRegErrorMsg, ::lstrlen(sRegErrorMsg));
	::RegCloseKey(hKey);
	
	SetErrorCount(dwErrorCount + 1);
}

void CRegistry::RemoveErrorAll()
{
	::RegDeleteKey(m_hKey, "ErrorReport");
}
*/

BOOL CRegistry::SetDialPlan(LPCTSTR sUserPrefix, CDialPlanReg* pDialPlanReg)
{
	HKEY hKey;
	
	char sSubKey[SUB_KEY_BUFFER_SIZE] = "\0";
	::_stprintf(sSubKey, "DialPlan\\%s", sUserPrefix); 
		
	if(::RegCreateKeyEx(m_hKey, sSubKey, 0, NULL, 0, KEY_ALL_ACCESS, NULL, &hKey, NULL) != ERROR_SUCCESS)
		return FALSE;

	if(::RegSetValueEx(hKey, "LineName", 0 , REG_SZ, (BYTE*) pDialPlanReg->m_sLineName.GetBuffer(0), pDialPlanReg->m_sLineName.GetLength()) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}
	
	if(::RegSetValueEx(hKey, "CallPrefix", 0 , REG_SZ, (BYTE*) pDialPlanReg->m_sCallPrefix.GetBuffer(0), pDialPlanReg->m_sCallPrefix.GetLength()) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}
	
	::RegCloseKey(hKey);

	return TRUE;

}


BOOL CRegistry::GetDialPlan(LPCTSTR sUserPrefix, CDialPlanReg* pDialPlanReg)
{
	HKEY hKey;
	
	char sBuff[SUB_KEY_BUFFER_SIZE] = "\0";
	::_stprintf(sBuff, "DialPlan\\%s", sUserPrefix); 

	if(::RegOpenKeyEx(m_hKey, sBuff, 0, KEY_ALL_ACCESS, &hKey) != ERROR_SUCCESS)
		return FALSE;
	
	::memset(sBuff, 0, SUB_KEY_BUFFER_SIZE);
	DWORD dwCount = SUB_KEY_BUFFER_SIZE;
	
	if(::RegQueryValueEx(hKey, "LineName", NULL, NULL, (BYTE*) sBuff, &dwCount) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}
	
	pDialPlanReg->m_sLineName = sBuff;

	::memset(sBuff, 0, SUB_KEY_BUFFER_SIZE);
	dwCount = SUB_KEY_BUFFER_SIZE;
	
	if(::RegQueryValueEx(hKey, "CallPrefix", NULL, NULL, (BYTE*) sBuff, &dwCount) != ERROR_SUCCESS)
	{
		::RegCloseKey(hKey);
		return FALSE;
	}
	
	pDialPlanReg->m_sCallPrefix = sBuff;

	::RegCloseKey(hKey);

	return TRUE;
}

void CRegistry::EnumDialPlan(CStringList* pDialPlanList)
{
	HKEY hKey;
		
	if(::RegOpenKeyEx(m_hKey, "DialPlan", 0, KEY_ALL_ACCESS, &hKey) != ERROR_SUCCESS)
		return;
	
	char sDialPlan[SUB_KEY_BUFFER_SIZE] = "\0";
	DWORD dwSize = SUB_KEY_BUFFER_SIZE;
	
	for(int nCount = 0;; nCount++)
	{
		if(::RegEnumKeyEx(hKey, nCount, sDialPlan, &dwSize, 0, NULL, NULL, NULL)  != ERROR_SUCCESS)
			break;
		
		pDialPlanList->AddTail(sDialPlan);

		::memset(sDialPlan, 0, SUB_KEY_BUFFER_SIZE);
		dwSize = SUB_KEY_BUFFER_SIZE;
	}

	::RegCloseKey(hKey);
}

BOOL CRegistry::RemoveDialPlan(LPCTSTR sUserPrefix)
{
	char sSubKey[SUB_KEY_BUFFER_SIZE] = "\0";
	::_stprintf(sSubKey, "DialPlan\\%s", sUserPrefix); 

	if(::RegDeleteKey(m_hKey, sSubKey) != ERROR_SUCCESS)
		return FALSE;

	return TRUE;
}


BOOL CRegistry::SetStartServer(BOOL bEnable)
{
	if(::RegSetValueEx(m_hKey, "ServerStart", 0 , REG_DWORD, (BYTE*) &bEnable, sizeof(DWORD)) != ERROR_SUCCESS)
		return FALSE;

	return TRUE;
}

BOOL CRegistry::GetStartServer()
{
	DWORD dwSize = sizeof(DWORD);
	DWORD dwValue = 0;
	
	if(::RegQueryValueEx(m_hKey, "ServerStart", NULL, NULL, (BYTE*) &dwValue, &dwSize) != ERROR_SUCCESS)
		return FALSE;
	
	return ((BOOL) dwValue);
}
