// VaxTeleCOM.cpp: implementation of the CVaxTeleCOM class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "VaxTeleCOM.h"
#include <afxctl.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

#ifdef __cplusplus
extern "C"{
#endif 

#ifndef __IID_DEFINED__
#define __IID_DEFINED__

typedef struct _IID
{
    unsigned long x;
    unsigned short s1;
    unsigned short s2;
    unsigned char  c[8];
} IID;

#endif // __IID_DEFINED__

#ifndef CLSID_DEFINED
#define CLSID_DEFINED
typedef IID CLSID;
#endif // CLSID_DEFINED

const IID LIBID_VAXTELESERVERSIPLib = {0xD3F0A4C5,0x34EA,0x4CCD,{0xB1,0xCA,0x94,0x70,0x7B,0x11,0xDC,0xA1}};
const IID DIID__IVaxTeleSIPEvents   = {0x9C401397,0x2AB5,0x478F,{0x86,0x6F,0x88,0x86,0x70,0x32,0x7A,0xFD}};
const IID IID_IVaxTeleSIP           = {0x56010105,0xC1E4,0x49D6,{0x86,0xE2,0xCD,0x97,0x1E,0x07,0xE4,0xAE}};
const CLSID CLSID_VaxTeleSIP        = {0xC5B1D5EB,0x680C,0x4B88,{0xAA,0x6D,0x30,0x5F,0x8B,0x84,0x31,0x1B}};

#ifdef __cplusplus
}
#endif


IMPLEMENT_DYNCREATE(CVaxTeleCOM, CCmdTarget)

CVaxTeleCOM::CVaxTeleCOM()
{
	EnableAutomation();
	
	m_pVaxTeleSIP = NULL;
	m_pVaxTeleSIPEvents = NULL;
}

CVaxTeleCOM::~CVaxTeleCOM()
{
	UnInitialize();
	UnInitObjectCOM();
}


void CVaxTeleCOM::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}


BEGIN_MESSAGE_MAP(CVaxTeleCOM, CCmdTarget)
	//{{AFX_MSG_MAP(CVaxTeleCOM)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CVaxTeleCOM, CCmdTarget)
	//{{AFX_DISPATCH_MAP(CVaxTeleCOM)
	DISP_FUNCTION(CVaxTeleCOM, "OnClientUnRegister", OnClientUnRegister, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION(CVaxTeleCOM, "OnClientRegister", OnClientRegister, VT_EMPTY, VTS_BSTR VTS_BSTR VTS_I4)
	DISP_FUNCTION(CVaxTeleCOM, "OnClientRegisterSuccess", OnClientRegisterSuccess, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION(CVaxTeleCOM, "OnClientRegisterFail", OnClientRegisterFail, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION(CVaxTeleCOM, "OnLineRegisterTrying", OnLineRegisterTrying, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CVaxTeleCOM, "OnLineRegisterFail", OnLineRegisterFail, VT_EMPTY, VTS_I4 VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxTeleCOM, "OnLineRegisterSuccess", OnLineRegisterSuccess, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CVaxTeleCOM, "OnLineUnRegisterTrying", OnLineUnRegisterTrying, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CVaxTeleCOM, "OnLineUnRegisterFail", OnLineUnRegisterFail, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CVaxTeleCOM, "OnLineUnRegisterSuccess", OnLineUnRegisterSuccess, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CVaxTeleCOM, "OnIncomingCallFromLine", OnIncomingCallFromLine, VT_EMPTY, VTS_I4 VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4)
	DISP_FUNCTION(CVaxTeleCOM, "OnIncomingCallFromUser", OnIncomingCallFromUser, VT_EMPTY, VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4)
	DISP_FUNCTION(CVaxTeleCOM, "OnIncomingCallAnonymous", OnIncomingCallAnonymous, VT_EMPTY, VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4)
	DISP_FUNCTION(CVaxTeleCOM, "OnIncomingCallCancel", OnIncomingCallCancel, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CVaxTeleCOM, "OnDialCallConnected", OnDialCallConnected, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CVaxTeleCOM, "OnAcceptIncomingCallConnected", OnAcceptIncomingCallConnected, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CVaxTeleCOM, "OnDisconnectCall", OnDisconnectCall, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CVaxTeleCOM, "OnProvisionalResponse", OnProvisionalResponse, VT_EMPTY, VTS_I4 VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxTeleCOM, "OnFailureResponse", OnFailureResponse, VT_EMPTY, VTS_I4 VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxTeleCOM, "OnRedirectionResponse", OnRedirectionResponse, VT_EMPTY, VTS_I4 VTS_I4 VTS_BSTR VTS_BSTR)
	DISP_FUNCTION(CVaxTeleCOM, "OnPlayWaveToSessionDone", OnPlayWaveToSessionDone, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxTeleCOM, "OnDigitDetectDTMF", OnDigitDetectDTMF, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxTeleCOM, "OnSessionLost", OnSessionLost, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CVaxTeleCOM, "OnTransferCallBlind", OnTransferCallBlind, VT_EMPTY, VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR)
	DISP_FUNCTION(CVaxTeleCOM, "OnTransferCallAttend", OnTransferCallAttend, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxTeleCOM, "OnHoldCall", OnHoldCall, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CVaxTeleCOM, "OffHoldCall", OffHoldCall, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CVaxTeleCOM, "OnDialCallTimeOut", OnDialCallTimeOut, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CVaxTeleCOM, "OnAcceptCallTimeOut", OnAcceptCallTimeOut, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CVaxTeleCOM, "OnVaxTeleTick", OnVaxTeleTick, VT_EMPTY, VTS_I4)
	
	
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_IVaxServerSIP to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {3DB0F857-BB81-4371-A80C-C4CB971721D1}
//static const IID IID_IVaxServerSIP =
//{ 0x3db0f857, 0xbb81, 0x4371, { 0xa8, 0xc, 0xc4, 0xcb, 0x97, 0x17, 0x21, 0xd1 } };

BEGIN_INTERFACE_MAP(CVaxTeleCOM, CCmdTarget)
	INTERFACE_PART(CVaxTeleCOM, DIID__IVaxTeleSIPEvents, Dispatch)
END_INTERFACE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVaxTeleCOM message handlers

void CVaxTeleCOM::UnInitObjectCOM()
{
	if(m_pVaxTeleSIP)
	{
		m_pVaxTeleSIP->Release();
		m_pVaxTeleSIP = NULL;
	}

	if(m_pVaxTeleSIPEvents)
	{
		LPUNKNOWN pUnk = GetIDispatch(FALSE);
		AfxConnectionUnadvise(m_pVaxTeleSIPEvents, DIID__IVaxTeleSIPEvents, pUnk, FALSE, m_dwCookie);

		m_pVaxTeleSIPEvents->Release();
		m_pVaxTeleSIPEvents = NULL;
	}
}

BOOL CVaxTeleCOM::InitObjectCOM()
{
	CoInitialize(NULL);
	
	HRESULT hr = CoCreateInstance(CLSID_VaxTeleSIP, NULL, CLSCTX_INPROC_SERVER, IID_IDispatch, (void**) &m_pVaxTeleSIPEvents);
	if(FAILED(hr)) return FALSE;

	m_pVaxTeleSIPEvents->QueryInterface(IID_IVaxTeleSIP, (void**) &m_pVaxTeleSIP);
	
	m_dwCookie = 1;
		
	LPUNKNOWN pUnk = GetIDispatch(FALSE);

	if(!AfxConnectionAdvise(m_pVaxTeleSIPEvents, DIID__IVaxTeleSIPEvents, pUnk, FALSE, &m_dwCookie))
	{
		return FALSE;
	}

	return TRUE;
}

void CVaxTeleCOM::SetLicenseKey(LPCTSTR sLicenseKey)
{
	m_pVaxTeleSIP->SetLicenseKey(sLicenseKey);
}

void CVaxTeleCOM::UnInitialize()
{
	if(m_pVaxTeleSIP)
		m_pVaxTeleSIP->UnInitialize();
}

BOOL CVaxTeleCOM::Initialize(LPCTSTR sDomainName, LPCTSTR sSIPListenIP, UINT nSIPListenPort, LPCTSTR sRTPListenIP, UINT nRTPListenPort)
{
	return m_pVaxTeleSIP->Initialize(sDomainName, sSIPListenIP, nSIPListenPort, sRTPListenIP, nRTPListenPort);
}

BOOL CVaxTeleCOM::AcceptCall(LONG lCallId, LPCTSTR sCodecList, LONG lTimeOut)
{
	return m_pVaxTeleSIP->AcceptCall(lCallId, sCodecList, lTimeOut);
}

BOOL CVaxTeleCOM::CloseCall(LONG lCallId)
{
	return m_pVaxTeleSIP->CloseCall(lCallId);
}

LONG CVaxTeleCOM::CreateSession()
{
	return m_pVaxTeleSIP->CreateSession();
}

BOOL CVaxTeleCOM::AddCallToSession(LONG lCallId, LONG lSessionId)
{
	return m_pVaxTeleSIP->AddCallToSession(lCallId, lSessionId);
}

BOOL CVaxTeleCOM::RemoveCallToSession(LONG lCallId)
{
	return m_pVaxTeleSIP->RemoveCallToSession(lCallId);
}

void CVaxTeleCOM::CloseSession(LONG lSessionId)
{
	m_pVaxTeleSIP->CloseSession(lSessionId);
}

LONG CVaxTeleCOM::GetVaxObjectError()
{
	return m_pVaxTeleSIP->GetVaxObjectError();
}

LONG CVaxTeleCOM::DialCallToUser(LPCTSTR sCallFrom, LPCTSTR sToUserLogin, LPCTSTR sCodecList, LONG lTimeOut)
{
	return m_pVaxTeleSIP->DialCallToUser(sCallFrom, sToUserLogin, sCodecList, lTimeOut);
}

LONG CVaxTeleCOM::DialCallToLine(LONG lLineId, LPCTSTR sDialNo, LPCTSTR sCodecList, LONG lTimeOut)
{
	return m_pVaxTeleSIP->DialCallToLine(lLineId, sDialNo, sCodecList, lTimeOut);
}

LONG CVaxTeleCOM::DialCallToURI(LPCTSTR sFromURI, LPCTSTR sToURI, LPCTSTR sProxyURI, LPCTSTR sLogin, LPCTSTR sLoginPwd, LPCTSTR sCodecList, LONG lTimeOut)
{
	return m_pVaxTeleSIP->DialCallToURI(sFromURI, sToURI, sProxyURI, sLogin, sLoginPwd, sCodecList, lTimeOut);
}
	
BOOL CVaxTeleCOM::SendResponse(LONG lCallId, int nStatusCode, LPCTSTR sReasonPhrase, LPCTSTR sCodecList)
{
	return m_pVaxTeleSIP->SendResponse(lCallId, nStatusCode, sReasonPhrase, sCodecList);
}

BOOL CVaxTeleCOM::RegisterLine(LONG lLineId)
{
	return m_pVaxTeleSIP->RegisterLine(lLineId);
}

BOOL CVaxTeleCOM::UnRegisterLine(LONG lLineId)
{
	return m_pVaxTeleSIP->UnRegisterLine(lLineId);
}

BOOL CVaxTeleCOM::AddLine(LONG lLineId, LPCTSTR sUserName, LPCTSTR sLogin, LPCTSTR sLoginPwd, LPCTSTR sDisplayName, LPCTSTR sDomainRealm, LPCTSTR sProxyURI,LPCTSTR sOutboundProxy)
{
	return m_pVaxTeleSIP->AddLine(lLineId, sUserName, sLogin, sLoginPwd, sDisplayName, sDomainRealm, sProxyURI, sOutboundProxy);
}

void CVaxTeleCOM::RemoveLine(LONG lLineId)
{
	m_pVaxTeleSIP->RemoveLine(lLineId);
}

BOOL CVaxTeleCOM::AddUser(LPCTSTR sUserLogin, LPCTSTR sLoginPwd)
{
	return m_pVaxTeleSIP->AddUser(sUserLogin, sLoginPwd);
}

void CVaxTeleCOM::RemoveUser(LPCTSTR sUserLogin)
{
	m_pVaxTeleSIP->RemoveUser(sUserLogin);
}

/*
BOOL CVaxTeleCOM::FindUser(LPCTSTR sUserLogin)
{
	return m_pVaxTeleSIP->FindUser(sUserLogin);
}
*/

BOOL CVaxTeleCOM::AuthClientRegister(LONG lRegId)
{
	return m_pVaxTeleSIP->AuthClientRegister(lRegId);
}

BOOL CVaxTeleCOM::AcceptClientRegister(LONG lRegId)
{
	return m_pVaxTeleSIP->AcceptClientRegister(lRegId);
}

BOOL CVaxTeleCOM::RejectClientRegister(LONG lRegId)
{
	return m_pVaxTeleSIP->RejectClientRegister(lRegId);
}

LONG CVaxTeleCOM::PlayWaveLoadFile(LPCTSTR sFileName)
{
	return m_pVaxTeleSIP->PlayWaveLoadFile(sFileName);
}

void CVaxTeleCOM::PlayWaveUnLoadFile(LONG lPlayWaveId)
{
	m_pVaxTeleSIP->PlayWaveUnLoadFile(lPlayWaveId);
}

BOOL CVaxTeleCOM::PlayWaveStartToSession(LONG lPlayWaveId, LONG lSessionId, BOOL bLoopPlay)
{
	return m_pVaxTeleSIP->PlayWaveStartToSession(lPlayWaveId, lSessionId, bLoopPlay);
}

BOOL CVaxTeleCOM::PlayWaveStopToSession(LONG lSessionId)
{
	return m_pVaxTeleSIP->PlayWaveStopToSession(lSessionId);
}

BOOL CVaxTeleCOM::PlayWaveResetToSession(LONG lSessionId)
{	
	return m_pVaxTeleSIP->PlayWaveResetToSession(lSessionId);
}

BOOL CVaxTeleCOM::RecordWaveStartToSession(LPCTSTR sFileName, LONG lSessionId)
{	
	return m_pVaxTeleSIP->RecordWaveStartToSession(sFileName, lSessionId);
}

BOOL CVaxTeleCOM::RecordWaveStopToSession(LONG lSessionId)
{
	return m_pVaxTeleSIP->RecordWaveStopToSession(lSessionId);
}

BOOL CVaxTeleCOM::RecordWavePauseToSession(BOOL bEnable, LONG lSessionId)
{
	return m_pVaxTeleSIP->RecordWavePauseToSession(bEnable, lSessionId);
}

BOOL CVaxTeleCOM::TransferCallAccept(LONG lCallId)
{
	return m_pVaxTeleSIP->TransferCallAccept(lCallId);
}

BOOL CVaxTeleCOM::TransferCallReject(LONG lCallId)
{
	return m_pVaxTeleSIP->TransferCallReject(lCallId);
}

BOOL CVaxTeleCOM::SendDTMF(int nTypeDTMF, LONG lCallId, int nDigit)
{
	return m_pVaxTeleSIP->SendDTMF(nTypeDTMF, lCallId, nDigit);
}

BOOL CVaxTeleCOM::DetectDTMF(int nTypeDTMF, LONG lSessionId, BOOL bEnable)
{
	return m_pVaxTeleSIP->DetectDTMF(nTypeDTMF, lSessionId, bEnable);
}

BOOL CVaxTeleCOM::SessionLost(BOOL bEnable)
{
	return m_pVaxTeleSIP->SessionLost(bEnable);
}

LONG CVaxTeleCOM::GetCallSession(LONG lCallId)
{
	return m_pVaxTeleSIP->GetCallSession(lCallId);
}

BOOL CVaxTeleCOM::EnableDialTone(LONG lCallId, LONG lSessionId)
{
	return m_pVaxTeleSIP->EnableDialTone(lCallId, lSessionId);
}

BOOL CVaxTeleCOM::DisableDialTone(LONG lCallId)
{
	return m_pVaxTeleSIP->DisableDialTone(lCallId);
}

BOOL CVaxTeleCOM::SetVaxTeleTick(LONG lTickId, LONG lElapse)
{
	return m_pVaxTeleSIP->SetVaxTeleTick(lTickId, lElapse);
}

BOOL CVaxTeleCOM::KillVaxTeleTick(LONG lTickId)
{	
	return m_pVaxTeleSIP->KillVaxTeleTick(lTickId);
}

int CVaxTeleCOM::GetCallTxCodecNo(LONG lCallId)
{
	return m_pVaxTeleSIP->GetCallTxCodecNo(lCallId);
}

int CVaxTeleCOM::GetCallRxCodecNo(LONG lCallId)
{
	return m_pVaxTeleSIP->GetCallRxCodecNo(lCallId);
}

void CVaxTeleCOM::OnClientUnRegister(LPCTSTR sUserLogin) 
{
}

void CVaxTeleCOM::OnClientRegister(LPCTSTR sUserLogin, LPCTSTR sDomain, long lRegId) 
{
}

void CVaxTeleCOM::OnClientRegisterSuccess(LPCTSTR sUserLogin) 
{
}

void CVaxTeleCOM::OnClientRegisterFail(LPCTSTR sUserLogin) 
{
}

void CVaxTeleCOM::OnLineRegisterTrying(long lLineId) 
{
}

void CVaxTeleCOM::OnLineRegisterFail(long lLineId, long lStatusCode, LPCTSTR sReasonPhrase) 
{
}

void CVaxTeleCOM::OnLineRegisterSuccess(long lLineId) 
{
}

void CVaxTeleCOM::OnIncomingCallFromLine(long lCallId, long lLineId, LPCTSTR sCallFrom, LPCTSTR sCallTo, LPCTSTR sFromURI, LPCTSTR sToURI, LPCTSTR sFromIP, long lFromPort) 
{
}

void CVaxTeleCOM::OnIncomingCallFromUser(long lCallId, LPCTSTR sUserName, LPCTSTR sCallFrom, LPCTSTR sCallTo, LPCTSTR sFromURI, LPCTSTR sToURI, LPCTSTR sFromIP, long lFromPort) 
{
}

void CVaxTeleCOM::OnIncomingCallAnonymous(long lCallId, LPCTSTR sCallFrom, LPCTSTR sCallTo, LPCTSTR sFromURI, LPCTSTR sToURI, LPCTSTR sFromIP, long lFromPort) 
{
}

void CVaxTeleCOM::OnIncomingCallCancel(long lCallId) 
{
}

void CVaxTeleCOM::OnDialCallConnected(long lCallId) 
{
}

void CVaxTeleCOM::OnAcceptIncomingCallConnected(long lCallId) 
{
}

void CVaxTeleCOM::OnDisconnectCall(long lCallId) 
{
}

void CVaxTeleCOM::OnProvisionalResponse(long lCallId, long lStatusCode, LPCTSTR sReasonPhrase) 
{
}

void CVaxTeleCOM::OnFailureResponse(long lCallId, long lStatusCode, LPCTSTR sReasonPhrase) 
{
}

void CVaxTeleCOM::OnRedirectionResponse(long lCallId, long lStatusCode, LPCTSTR sReasonPhrase, LPCTSTR sContact) 
{
}

void CVaxTeleCOM::OnPlayWaveToSessionDone(long lPlayWaveId, long lSessionId) 
{
}

void CVaxTeleCOM::OnDigitDetectDTMF(long lSessionId, long lCallId, long lDigit) 
{
}

void CVaxTeleCOM::OnSessionLost(long lCallId) 
{
}

void CVaxTeleCOM::OnTransferCallBlind(long lCallId, LPCTSTR sTransferee, LPCTSTR sTransferTo, LPCTSTR sTransferToURI) 
{
}

void CVaxTeleCOM::OnTransferCallAttend(long lCallId, long lTransferToCallId) 
{
}

void CVaxTeleCOM::OnHoldCall(long lCallId) 
{
}

void CVaxTeleCOM::OffHoldCall(long lCallId) 
{
}

void CVaxTeleCOM::OnDialCallTimeOut(long lCallId) 
{
}

void CVaxTeleCOM::OnAcceptCallTimeOut(long lCallId) 
{
}

void CVaxTeleCOM::OnVaxTeleTick(long lTickId)
{
}


void CVaxTeleCOM::OnLineUnRegisterTrying(long lLineId) 
{
}

void CVaxTeleCOM::OnLineUnRegisterFail(long lLineId)
{
}

void CVaxTeleCOM::OnLineUnRegisterSuccess(long lLineId) 
{
}

