using System;
using System.Collections;
using System.Text;


class cLineData
{
    public int m_nLineId;

    public int m_nCallType;
    public string m_sCallTo;

    public string m_sLineName;
    public string m_sCodecList;

    public Boolean m_bRegister;

    public cLineData()
    {
        m_sCodecList = "";
        m_sLineName = "";
        m_nLineId = 0;
        m_nCallType = -1;
        m_bRegister = false;
    }
}

class cLineList
{
    int m_nLineIdCount;

    Hashtable m_objLineListTEXT = new Hashtable();
    Hashtable m_objLineListINT = new Hashtable();

    ~cLineList()
    {
        m_nLineIdCount = 0;
    }

    public int ChooseLineId()
    {
        while (true)
        {
            m_nLineIdCount++;
            if (FindLine(m_nLineIdCount) == null) break;
        }

        return m_nLineIdCount;
    }

    public void UnLoadLines()
    {
        ArrayList objCloseLineList = new ArrayList();
        IDictionaryEnumerator enumerator = m_objLineListTEXT.GetEnumerator();

        while(enumerator.MoveNext())
            objCloseLineList.Add(enumerator.Key);

        for(int nCount = 0; nCount < objCloseLineList.Count; nCount++)
            Remove((string) objCloseLineList[nCount]);
        
        m_objLineListTEXT.Clear();
        m_objLineListINT.Clear();

    }

    public void LoadLines()
    {
        UnLoadLines();

        ArrayList objLineList = new ArrayList();
        cRegistry objReg = new cRegistry();

        objReg.EnumLine(ref objLineList);

        cLineReg objLineReg = new cLineReg();

        for(int nCount = 0; nCount < objLineList.Count; nCount++)
        {
            string sLineName = (string) objLineList[nCount];

            if(objReg.GetLine(sLineName, ref objLineReg) == false)
            {
                cServerSIP.m_objServerSIP.LogError("Unable to extract line information from registry.");
                continue;
            }

            Add(sLineName, objLineReg.m_sDisplayName, objLineReg.m_sUserName, objLineReg.m_sAuthUser, objLineReg.m_sPassword, objLineReg.m_sRealm, objLineReg.m_sProxy, objLineReg.m_sOutboundProxy, objLineReg.m_sCodec, objLineReg.m_bRegister, objLineReg.m_sInCallType, objLineReg.m_sInCallTo);
        }
    }

    public Boolean AddLine(string sLineName, string sDisplayName, string sUserName, string sAuthUser, string sAuthPwd, string sRealm, string sProxy, string sOutboundProxy, string sCodec, Boolean bRegister, string sInCallType, string sInCallTo)
    {
        cLineReg objLineReg = new cLineReg();

        objLineReg.m_sDisplayName = sDisplayName;
        objLineReg.m_sUserName = sUserName;
        objLineReg.m_sAuthUser = sAuthUser;
        objLineReg.m_sPassword = sAuthPwd;
        objLineReg.m_sRealm = sRealm;
        objLineReg.m_sProxy = sProxy;
        objLineReg.m_sOutboundProxy = sOutboundProxy;
        objLineReg.m_sCodec = sCodec;

        objLineReg.m_bRegister = bRegister;

        objLineReg.m_sInCallType = sInCallType;
        objLineReg.m_sInCallTo = sInCallTo;

        cRegistry objReg = new cRegistry();
        if(objReg.SetLine(sLineName, ref objLineReg) == false)
            return false;

        Add(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sRealm, sProxy, sOutboundProxy, sCodec, bRegister, sInCallType, sInCallTo);
        
        return true;
    }

    public Boolean RemoveLine(string sLineName)
    {
        cRegistry objReg = new cRegistry();

        if(objReg.RemoveLine(sLineName) == false)
            return false;

        Remove(sLineName);
        return true;
    }

    public void Add(string sLineName, string sDisplayName, string sUserName, string sAuthUser, string sAuthPwd, string sRealm, string sProxy, string sOutboundProxy, string sCodec, Boolean bRegister, string sInCallType, string sInCallTo)
    {
        Remove(sLineName);

        cLineData objLineData = new cLineData();

        objLineData.m_nCallType = Convert.ToInt32(sInCallType);
        objLineData.m_sCallTo = sInCallTo;
        objLineData.m_bRegister = bRegister;

        objLineData.m_sLineName = sLineName;
        objLineData.m_sCodecList = sCodec;

        int nLineId = ChooseLineId();
        objLineData.m_nLineId = nLineId;

        m_objLineListINT.Add(nLineId, objLineData);

        sLineName = sLineName.ToLower();
        m_objLineListTEXT.Add(sLineName, objLineData);

        if(cServerSIP.m_objServerSIP.AddLine(nLineId, sUserName, sAuthUser, sAuthPwd, sDisplayName, sRealm, sProxy, sOutboundProxy) == false)
        {
            cServerSIP.m_objServerSIP.LogError("");
            return;
        }

        if(bRegister)
        {
            if(cServerSIP.m_objServerSIP.RegisterLine(nLineId) == false)
                cServerSIP.m_objServerSIP.LogError("");
        }
    }

    public void Remove(string sLineName)
    {
        sLineName = sLineName.ToLower();

        cLineData objLineData = FindLine(sLineName);
        if(objLineData == null) return;

        m_objLineListINT.Remove(objLineData.m_nLineId);
        m_objLineListTEXT.Remove(sLineName);

        if(objLineData.m_bRegister)
            cServerSIP.m_objServerSIP.UnRegisterLine(objLineData.m_nLineId);
        
        objLineData = null;
    }

    public cLineData FindLine(int nLineId)
    {
        return (cLineData) m_objLineListINT[nLineId];
    }

    public cLineData FindLine(string sLineName)
    {
        return (cLineData) m_objLineListTEXT[sLineName.ToLower()];
    }
}

