using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;


class cTelnetCmd
{
    public void ShowUsers(ref cTelnetClient objTelnetClient)
    {
        cRegistry objReg = new cRegistry();

        ArrayList objLoginList = new ArrayList();
        objReg.EnumLogin(ref objLoginList);

        objTelnetClient.SendCommand("ShowUsers", ref objLoginList);
        objTelnetClient.SendText("VaxTele:>");

    }

    public void UserInfo(ref ArrayList objParamList, ref cTelnetClient objTelnetClient)
    {
        string sLogin = (string) objParamList[0];

        cRegistry objReg = new cRegistry();
        
        cLoginReg objLoginReg = new cLoginReg();
        ArrayList objSendParamList = new ArrayList();

        if(objReg.GetLogin(sLogin, ref objLoginReg)== false)
        {
            objSendParamList.Add("User not found.");
            objTelnetClient.SendCommand("MSG", ref objSendParamList);
            objTelnetClient.SendText("VaxTele:>");

            return;
        }

        objSendParamList.Add(sLogin);
        objSendParamList.Add(objLoginReg.m_sPassword);
        objSendParamList.Add(objLoginReg.m_sCodec);

        if(objLoginReg.m_bStealth)
            objSendParamList.Add("STEALTH-YES");
        else
            objSendParamList.Add("STEALTH-NO");
        

        if(objLoginReg.m_bBlock)
            objSendParamList.Add("BLOCK-YES");
        else
            objSendParamList.Add("BLOCK-NO");
        
        objTelnetClient.SendCommand("UserInfo", ref objSendParamList);
        objTelnetClient.SendText("VaxTele:>");
    }

    public void AddUser(ref ArrayList objParamList, ref cTelnetClient objTelnetClient)
    {
        string sLogin = (string) objParamList[0];

        cRegistry objReg = new cRegistry();
        cLoginReg objLoginReg = new cLoginReg();

        objLoginReg.m_sPassword = (string) objParamList[1];
        objLoginReg.m_sCodec = (string) objParamList[2];

        objLoginReg.m_bStealth = ((string) objParamList[3] == "STEALTH-YES");
        objLoginReg.m_bBlock = ((string) objParamList[4] == "BLOCK-YES");

        Boolean bUpdate = objReg.IsLoginExist(sLogin);
        ArrayList objSendParamList = new ArrayList();

        if(objReg.SetLogin(sLogin, ref objLoginReg) == false)
        {
            objSendParamList.Add("Unable to add user.");

            objTelnetClient.SendCommand("MSG", ref objSendParamList);
            objTelnetClient.SendText("VaxTele:>");
            
            return;
        }

        objSendParamList.Add(sLogin);

        if(bUpdate)
            objTelnetClient.SendCommand("UpdateUser", ref objSendParamList);
        else
            objTelnetClient.SendCommand("AddUser", ref objSendParamList);
        
        objTelnetClient.SendText("VaxTele:>");
    }

    public void RemoveUser(ref ArrayList objParamList, ref cTelnetClient objTelnetClient)
    {
        string sLogin = (string) objParamList[0];

        cRegistry objReg = new cRegistry();
        ArrayList objSendParamList = new ArrayList();

        if(objReg.RemoveLogin(sLogin) == false)
        {
            objSendParamList.Add("Unable to remove user.");
            objTelnetClient.SendCommand("MSG", ref objSendParamList);
            objTelnetClient.SendText("VaxTele:>");

            return;
        }

        objSendParamList.Add(sLogin);

        objTelnetClient.SendCommand("RemoveUser", ref objSendParamList);
        objTelnetClient.SendText("VaxTele:>");
    }

    /**********************************************/

    public void ShowQueues(ref cTelnetClient objTelnetClient)
    {
        cRegistry objReg = new cRegistry();
        ArrayList objQueueList = new ArrayList();

        objReg.EnumQueue(ref objQueueList);

        objTelnetClient.SendCommand("ShowQueues", ref objQueueList);
        objTelnetClient.SendText("VaxTele:>");
    }

    public void QueueInfo(ref ArrayList objParamList, ref cTelnetClient objTelnetClient)
    {
        string sQueueName = (string) objParamList[0];

        cRegistry objReg = new cRegistry();
        cQueueReg objQueueReg = new cQueueReg();
        ArrayList objSendParamList = new ArrayList();

        if(objReg.GetQueue(sQueueName, ref objQueueReg) == false)
        {
            objSendParamList.Add("Queue not found.");

            objTelnetClient.SendCommand("MSG", ref objSendParamList);
            objTelnetClient.SendText("VaxTele:>");

            return;
        }

        objSendParamList.Add(sQueueName);
        objSendParamList.Add(objQueueReg.m_sPlayWave);
        objSendParamList.Add(objQueueReg.m_sPressDigitPlayWave);

        ////////////////////////////////////////////

        string sQueueOPList = "";
        
        PrepareToStr(ref objQueueReg.m_objQueueOPList, ref sQueueOPList);
        objSendParamList.Add(sQueueOPList);

        ////////////////////////////////////////////

        string sPressDigitList = "";
        
        PrepareToStr(ref objQueueReg.m_objPressDigitList, ref sPressDigitList);
        objSendParamList.Add(sPressDigitList);

        ////////////////////////////////////////////
        
        string sPressDigitUserList = "";
        
        PrepareToStr(ref objQueueReg.m_objPressDigitUserList, ref sPressDigitUserList);
        objSendParamList.Add(sPressDigitUserList);

        ////////////////////////////////////////////

        objTelnetClient.SendCommand("QueueInfo", ref objSendParamList);
        objTelnetClient.SendText("VaxTele:>");
    }

    public void AddQueue(ref ArrayList objParamList, ref cTelnetClient objTelnetClient)
    {
        string sQueueName = (string) objParamList[0];

        ///////////////////////////////////////

        Boolean bUpdate = (cServerSIP.m_objServerSIP.m_objQueueList.FindQueue(sQueueName) != null);

        ///////////////////////////////////////

        string sPlayWave = (string) objParamList[1];
        string sPressDigitPlayWave = (string) objParamList[2];

        ///////////////////////////////////////
             
        ArrayList objQueueOPList = new ArrayList();
        ParseToList((string)objParamList[3], ref objQueueOPList);
                
        ///////////////////////////////////////
                        
        ArrayList objPressDigitList = new ArrayList();
        ParseToList((string)objParamList[4], ref objPressDigitList);

        ///////////////////////////////////////

        ArrayList objPressDigitUserList = new ArrayList();
        ParseToList((string)objParamList[5], ref objPressDigitUserList);
                
        ///////////////////////////////////////

        ArrayList objSendParamList = new ArrayList();

        if(cServerSIP.m_objServerSIP.m_objQueueList.AddQueue(sQueueName, sPlayWave, sPressDigitPlayWave, ref objQueueOPList, ref objPressDigitList, ref objPressDigitUserList) == false)
        {
            objSendParamList.Add("Unable to add queue.");

            objTelnetClient.SendCommand("MSG", ref objSendParamList);
            objTelnetClient.SendText("VaxTele:>");

            return;
        }

        objSendParamList.Add(sQueueName);

        if(bUpdate)
            objTelnetClient.SendCommand("UpdateQueue", ref objSendParamList);
        else
            objTelnetClient.SendCommand("AddQueue", ref objSendParamList);
        
        objTelnetClient.SendText("VaxTele:>");
    }


    public void RemoveQueue(ref ArrayList objParamList, ref cTelnetClient objTelnetClient)
    {
        string sQueueName = (string) objParamList[0];
        cServerSIP.m_objServerSIP.m_objQueueList.RemoveQueue(sQueueName);

        ArrayList objSendParamList = new ArrayList();
        objSendParamList.Add(sQueueName);

        objTelnetClient.SendCommand("RemoveQueue", ref objSendParamList);
        objTelnetClient.SendText("VaxTele:>");
    }

    /**********************************************/

    public void ShowLines(ref cTelnetClient objTelnetClient)
    {
        cRegistry objReg = new cRegistry();

        ArrayList objLineList = new ArrayList();
        objReg.EnumLine(ref objLineList);

        objTelnetClient.SendCommand("ShowLines", ref objLineList);
        objTelnetClient.SendText("VaxTele:>");
    }

    public void LineInfo(ref ArrayList objParamList, ref cTelnetClient objTelnetClient)
    {
        string sLineName = (string) objParamList[0];

        cRegistry objReg = new cRegistry();

        cLineReg objLineReg = new cLineReg();
        ArrayList objSendParamList = new ArrayList();

        if(!objReg.GetLine(sLineName, ref objLineReg))
        {
            objSendParamList.Add("Line not found.");

            objTelnetClient.SendCommand("MSG", ref objSendParamList);
            objTelnetClient.SendText("VaxTele:>");

            return;
        }

        objSendParamList.Add(sLineName);

        objSendParamList.Add(objLineReg.m_sDisplayName);
        objSendParamList.Add(objLineReg.m_sUserName);
        objSendParamList.Add(objLineReg.m_sAuthUser);
        objSendParamList.Add(objLineReg.m_sPassword);
        objSendParamList.Add(objLineReg.m_sRealm);
        objSendParamList.Add(objLineReg.m_sProxy);
        objSendParamList.Add(objLineReg.m_sOutboundProxy);
        objSendParamList.Add(objLineReg.m_sCodec);

        if(objLineReg.m_bRegister)
            objSendParamList.Add("REGISTER-YES");
        else
            objSendParamList.Add("REGISTER-NO");
                
        objSendParamList.Add(objLineReg.m_sInCallType);
        objSendParamList.Add(objLineReg.m_sInCallTo);

        objTelnetClient.SendCommand("LineInfo", ref objSendParamList);
        objTelnetClient.SendText("VaxTele:>");

    }
    
    public void AddLine(ref ArrayList objParamList, ref cTelnetClient objTelnetClient)
    {
        string sLineName = (string) objParamList[0];
        string sDisplayName = (string) objParamList[1];
        string sUserName = (string) objParamList[2];
        string sAuthUser = (string) objParamList[3];
        string sAuthPwd = (string) objParamList[4];
        string sRealm = (string) objParamList[5];
        string sProxy = (string) objParamList[6];
        string sOutboundProxy = (string) objParamList[7];
        string sCodec = (string) objParamList[8];

        Boolean bRegister = ((string) objParamList[9] == "REGISTER-YES");

        string sInCallType = (string) objParamList[10];
        string sInCallTo = (string) objParamList[11];

        Boolean bUpdate = (cServerSIP.m_objServerSIP.m_objLineList.FindLine(sLineName) != null);

        ArrayList objSendParamList = new ArrayList();

        if(!cServerSIP.m_objServerSIP.m_objLineList.AddLine(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sRealm, sProxy, sOutboundProxy, sCodec, bRegister, sInCallType, sInCallTo))
        {
            objSendParamList.Add("Unable to add line.");

            objTelnetClient.SendCommand("MSG", ref objSendParamList);
            objTelnetClient.SendText("VaxTele:>");

            return;
        }

        objSendParamList.Add(sLineName);

        if(bUpdate)
            objTelnetClient.SendCommand("UpdateLine", ref objSendParamList);
        else
            objTelnetClient.SendCommand("AddLine", ref objSendParamList);
        
        objTelnetClient.SendText("VaxTele:>");
    }

    public void RemoveLine(ref ArrayList objParamList, ref cTelnetClient objTelnetClient)
    {
        string sLineName = (string) objParamList[0];
        ArrayList objSendParamList = new ArrayList();

        if(!cServerSIP.m_objServerSIP.m_objLineList.RemoveLine(sLineName))
        {
            objSendParamList.Add("Unable to remove line.");

            objTelnetClient.SendCommand("MSG", ref objSendParamList);
            objTelnetClient.SendText("VaxTele:>");

            return;
        }

        objSendParamList.Add(sLineName);

        objTelnetClient.SendCommand("RemoveLine", ref objSendParamList);
        objTelnetClient.SendText("VaxTele:>");
    }

    /**********************************************/

    public void ShowDialPlans(ref cTelnetClient objTelnetClient)
    {
        cRegistry objReg = new cRegistry();

        ArrayList objDialPlanList = new ArrayList();
        objReg.EnumDialPlan(ref objDialPlanList);

        cDialPlanReg objDialPlanReg = new cDialPlanReg();
        ArrayList objSendParamList = new ArrayList();
                
        for(int nCount = 0; nCount < objDialPlanList.Count; nCount++)
        {
            string sUserPrefix = (string)objDialPlanList[nCount];
            objReg.GetDialPlan(sUserPrefix, ref objDialPlanReg);

            if (objDialPlanReg.m_sCallPrefix.Length == 0)
                objDialPlanReg.m_sCallPrefix = "None";

            objSendParamList.Add(sUserPrefix + "," + objDialPlanReg.m_sLineName + "," + objDialPlanReg.m_sCallPrefix);
        }

        objTelnetClient.SendCommand("ShowDialPlans", ref objSendParamList);
        objTelnetClient.SendText("VaxTele:>");
    }

    public void DialPlanInfo(ref ArrayList objParamList, ref cTelnetClient objTelnetClient)
    {
        string sUserPrefix = (string) objParamList[0];

        cRegistry objReg = new cRegistry();
        cDialPlanReg objDialPlanReg = new cDialPlanReg();

        ArrayList objSendParamList = new ArrayList();

        if(!objReg.GetDialPlan(sUserPrefix, ref objDialPlanReg))
        {
            objSendParamList.Add("DialPlan or user prefix not found.");

            objTelnetClient.SendCommand("MSG", ref objSendParamList);
            objTelnetClient.SendText("VaxTele:>");

            return;
        }

        objSendParamList.Add(sUserPrefix);
        objSendParamList.Add(objDialPlanReg.m_sLineName);

        if (objDialPlanReg.m_sCallPrefix.Length == 0)
            objDialPlanReg.m_sCallPrefix = "None";

        objSendParamList.Add(objDialPlanReg.m_sCallPrefix);

        objTelnetClient.SendCommand("DialPlanInfo", ref objSendParamList);
        objTelnetClient.SendText("VaxTele:>");

    }

    public void AddDialPlan(ref ArrayList objParamList, ref cTelnetClient objTelnetClient)
    {
        string sUserPrefix = (string) objParamList[0];

        cRegistry objReg = new cRegistry();
        cDialPlanReg objDialPlanReg = new cDialPlanReg();
        ArrayList objSendParamList = new ArrayList();

        objDialPlanReg.m_sLineName = (string) objParamList[1];
        objDialPlanReg.m_sCallPrefix = (string) objParamList[2];

        if(objReg.SetDialPlan(sUserPrefix, ref objDialPlanReg) == false)
        {
            objSendParamList.Add("Unable to add dialplan or user prefix.");

            objTelnetClient.SendCommand("MSG", ref objSendParamList);
            objTelnetClient.SendText("VaxTele:>");

            return;
        }

        cServerSIP.m_objServerSIP.m_objDialPlanList.ReLoadDialPlans();

        objSendParamList.Add(sUserPrefix);
        objSendParamList.Add(objDialPlanReg.m_sLineName);

        if (objDialPlanReg.m_sCallPrefix.Length == 0)
            objDialPlanReg.m_sCallPrefix = "None";

        objSendParamList.Add(objDialPlanReg.m_sCallPrefix);

        objTelnetClient.SendCommand("AddDialPlan", ref objSendParamList);
        objTelnetClient.SendText("VaxTele:>");

    }

    public void RemoveDialPlan(ref ArrayList objParamList, ref cTelnetClient objTelnetClient)
    {
        string sUserPrefix = (string) objParamList[0];

        ArrayList objSendParamList = new ArrayList();
        cRegistry objReg = new cRegistry();

        if(objReg.RemoveDialPlan(sUserPrefix) == false)
        {
            objSendParamList.Add("Unable to remove dialplan or user prefix.");
            objTelnetClient.SendCommand("MSG", ref objSendParamList);

            objTelnetClient.SendText("VaxTele:>");
            return;
        }
        
        cServerSIP.m_objServerSIP.m_objDialPlanList.ReLoadDialPlans();

        objSendParamList.Add(sUserPrefix);

        objTelnetClient.SendCommand("RemoveDialPlan", ref objSendParamList);
        objTelnetClient.SendText("VaxTele:>");
    }

    /*************************************************/

    public void SetStealthMusic(ref ArrayList objParamList, ref cTelnetClient objTelnetClient)
    {
        string sStealthMusic = (string) objParamList[0];

        cRegistry objReg = new cRegistry();
        objReg.SetStealthListenerMusic(sStealthMusic);

        ArrayList objSendParamList = new ArrayList();
        objSendParamList.Add(sStealthMusic);

        objTelnetClient.SendCommand("SetStealthMusic", ref objSendParamList);
        objTelnetClient.SendText("VaxTele:>");
    }

    public void GetStealthMusic(ref cTelnetClient objTelnetClient)
    {
        cRegistry objReg = new cRegistry();

        ArrayList objSendParamList = new ArrayList();
        objSendParamList.Add(objReg.GetStealthListenerMusic());

        objTelnetClient.SendCommand("GetStealthMusic", ref objSendParamList);
        objTelnetClient.SendText("VaxTele:>");
    }

    /*************************************************/

    public void SetHoldMusic(ref ArrayList objParamList, ref cTelnetClient objTelnetClient)
    {
        string sHoldMusic = (string) objParamList[0];

        cRegistry objReg = new cRegistry();
        objReg.SetHoldMusic(sHoldMusic);

        ArrayList objSendParamList = new ArrayList();
        objSendParamList.Add(sHoldMusic);

        objTelnetClient.SendCommand("SetHoldMusic", ref objSendParamList);
        objTelnetClient.SendText("VaxTele:>");

    }

    public void GetHoldMusic(ref cTelnetClient objTelnetClient)
    {
        cRegistry objReg = new cRegistry();

        ArrayList objSendParamList = new ArrayList();
        objSendParamList.Add(objReg.GetHoldMusic());

        objTelnetClient.SendCommand("GetHoldMusic", ref objSendParamList);
        objTelnetClient.SendText("VaxTele:>");
    }

    /*************************************************/

    public void SetDialToneMusic(ref ArrayList objParamList, ref cTelnetClient objTelnetClient)
    {
        string sDialToneMusic = (string) objParamList[0];

        cRegistry objReg = new cRegistry();
        objReg.SetDialToneMusic(sDialToneMusic);

        ArrayList objSendParamList = new ArrayList();
        objSendParamList.Add(sDialToneMusic);

        objTelnetClient.SendCommand("SetDialToneMusic", ref objSendParamList);
        objTelnetClient.SendText("VaxTele:>");
    }

    public void GetDialToneMusic(ref cTelnetClient objTelnetClient)
    {
        cRegistry objReg = new cRegistry();

        ArrayList objSendParamList = new ArrayList();
        objSendParamList.Add(objReg.GetDialToneMusic());

        objTelnetClient.SendCommand("GetDialToneMusic", ref objSendParamList);
        objTelnetClient.SendText("VaxTele:>");
    }

    /*************************************************/

    public void GetCOMM(ref cTelnetClient objTelnetClient)
    {
        cRegistry objReg = new cRegistry();
        cDialPlanReg objDialPlanReg = new cDialPlanReg();

        string sListenIP = "";
        string sListenPort = "";
        string sDominRealm = "";

        objReg.GetComm(ref sListenIP, ref sListenPort, ref sDominRealm);

        ArrayList objSendParamList = new ArrayList();

        objSendParamList.Add(sListenIP);
        objSendParamList.Add(sListenPort);
        objSendParamList.Add(sDominRealm);

        objTelnetClient.SendCommand("GetCOMM", ref objSendParamList);
        objTelnetClient.SendText("VaxTele:>");
    }

    public void SetCOMM(ref ArrayList objParamList, ref cTelnetClient objTelnetClient)
    {
        cRegistry objReg = new cRegistry();
        cDialPlanReg objDialPlanReg = new cDialPlanReg();

        string sListenIP = (string) objParamList[0];
        string sListenPort = (string) objParamList[1];
        string sDominRealm = (string) objParamList[2];

        objReg.SetComm(sListenIP, sListenPort, sDominRealm);

        objTelnetClient.SendCommand("SetCOMM", ref objParamList);
        objTelnetClient.SendText("VaxTele:>");
    }

    ///////////////////////////////////////////

    public void StartServer(ref cTelnetClient objTelnetClient)
    {
        cRegistry objReg = new cRegistry();
        objReg.SetStartServer(true);

        objTelnetClient.SendText("VaxTele:>");
    }

    public void StopServer(ref cTelnetClient objTelnetClient)
    {
        cRegistry objReg = new cRegistry();
        objReg.SetStartServer(false);

        objTelnetClient.SendText("VaxTele:>");
    }

    /////////////////////////////////////////

    public void InvalidCommand(ref cTelnetClient objTelnetClient)
    {
        objTelnetClient.SendText("VaxTele:>");
    }

    /////////////////////////////////////////

    public void ParseToList(string sInputStr, ref ArrayList objOutputList)
    {
        int nEnd = 0;

        while (sInputStr.Length != 0)
        {
            nEnd = sInputStr.IndexOf(",");

            if (nEnd == -1)
            {
                objOutputList.Add(sInputStr);
                break;
            }

            objOutputList.Add(sInputStr.Substring(0, nEnd));
            sInputStr = sInputStr.Remove(0, nEnd + 1);
        }
    }

    public void PrepareToStr(ref ArrayList objInputList, ref string sOutputStr)
    {
        sOutputStr = "";
        int nCount = 0;

        for (nCount = 0; nCount < objInputList.Count; nCount++)
            sOutputStr = sOutputStr + objInputList[nCount] + ",";

        if (nCount > 0)
            sOutputStr = sOutputStr.Remove(sOutputStr.Length - 1, 1); // remove last comma ','
    }


}

